#include <winsock2.h>
#include <windows.h>


int
Test_remote_port(char *address, int port)
{
	SOCKET sock;
	struct sockaddr_in addr;

	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    {
      return false;
    }
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = inet_addr(address);
	if (addr.sin_addr.s_addr == INADDR_NONE)
	    {
		struct hostent *pHost;
		pHost = gethostbyname(address);
		if (pHost != NULL)
		{
			if (pHost->h_addr == NULL)
				return false;
			addr.sin_addr.s_addr = ((struct in_addr *)pHost->h_addr)->s_addr;
		}
		else
		    return false;
	    }
	addr.sin_port = htons(port);
	if (!connect(sock, (struct sockaddr *)&addr, sizeof(addr)) == 0)
	{
	    return false;
	}

	shutdown(sock, SD_BOTH);
	closesocket(sock);
	return true;
}

int
Set_dynamic_host(char *myhost, char *address, unsigned int port)
{
	SOCKET sock;
	struct sockaddr_in addr;

	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    {
      return false;
    }
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = inet_addr(address);
	if (addr.sin_addr.s_addr == INADDR_NONE)
	    {
		struct hostent *pHost;
		pHost = gethostbyname(address);
		if (pHost != NULL)
		{
			if (pHost->h_addr == NULL)
				return false;
			addr.sin_addr.s_addr = ((struct in_addr *)pHost->h_addr)->s_addr;
		}
		else
		    return false;
	    }
	addr.sin_port = htons(port);
	if (!connect(sock, (struct sockaddr *)&addr, sizeof(addr)) == 0)
	{
	    return false;
	}

	int timeout=5000;
	if (setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, (char*)&timeout, sizeof(timeout)) == SOCKET_ERROR)
	{
		return false;
	}
	if (setsockopt(sock, SOL_SOCKET, SO_SNDTIMEO, (char*)&timeout, sizeof(timeout)) == SOCKET_ERROR)
	{
		return false;
	}
	char temp [300];
	strcpy(temp,"IPS:");
	strcat(temp,myhost);
	send(sock, temp, 250, 0);
	shutdown(sock, SD_BOTH);
	closesocket(sock);
	return true;
}

int
Get_dynamic_host(char *myhost, char *address, unsigned int port,char *viewer_ip)
{
	SOCKET sock;
	struct sockaddr_in addr;

	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    {
      return false;
    }
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = inet_addr(address);
	if (addr.sin_addr.s_addr == INADDR_NONE)
	    {
		struct hostent *pHost;
		pHost = gethostbyname(address);
		if (pHost != NULL)
		{
			if (pHost->h_addr == NULL)
				return false;
			addr.sin_addr.s_addr = ((struct in_addr *)pHost->h_addr)->s_addr;
		}
		else
		    return false;
	    }
	addr.sin_port = htons(port);
	if (!connect(sock, (struct sockaddr *)&addr, sizeof(addr)) == 0)
	{
	    return false;
	}

	int timeout=5000;
	if (setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, (char*)&timeout, sizeof(timeout)) == SOCKET_ERROR)
	{
		return false;
	}
	if (setsockopt(sock, SOL_SOCKET, SO_SNDTIMEO, (char*)&timeout, sizeof(timeout)) == SOCKET_ERROR)
	{
		return false;
	}
	char temp [300];
	strcpy(temp,"IPG:");
	strcat(temp,myhost);
	send(sock, temp, 250, 0);
	recv(sock, viewer_ip, 32, 0);


	shutdown(sock, SD_BOTH);
	closesocket(sock);
	return true;
}